=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2010-11-26 06:31:54 +0000
+++ bzrlib/smart/repository.py	2011-09-02 23:13:18 +0000
@@ -238,7 +238,7 @@
                 next_revs = set()
                 break
             # don't query things we've already queried
-            next_revs.difference_update(queried_revs)
+            next_revs = next_revs.difference(queried_revs)
             first_loop_done = True
 
         # sorting trivially puts lexographically similar revision ids together.

=== modified file 'doc/en/release-notes/bzr-2.3.txt'
--- doc/en/release-notes/bzr-2.3.txt	2011-08-20 18:29:34 +0000
+++ doc/en/release-notes/bzr-2.3.txt	2011-09-02 23:13:18 +0000
@@ -87,6 +87,11 @@
 .. Improvements to existing commands, especially improved performance 
    or memory usage, or better results.
 
+* Tweak an RPC implementation for ``Repository.get_parent_map``, it was
+  doing an inefficient ``small_set.difference_update(large_set)`` when we
+  can do ``small_set = small_set.difference(large_set)``. This speeds up
+  discovery time by about 10%. (John Arbash Meinel)
+
 Bug Fixes
 *********
 

